OPT_RWE equ TRUE

; +
;
MmMap proc uses ebx esi S1ze:ULONG, ExBase:PPVOID, RwBase:PPVOID
Local Obj:OBJECT_ATTRIBUTES
Local Section:HANDLE
Local SectionSize:LARGE_INTEGER
Local SectionOffset:LARGE_INTEGER
	mov eax,S1ze
	xor esi,esi
	mov D[SectionSize][0],eax
	mov Obj.uLength,sizeof(OBJECT_ATTRIBUTES)
	mov D[SectionSize][4],esi
	mov Obj.hRootDirectory,esi
	mov Obj.pObjectName,esi
	mov Obj.uAttributes,esi
	mov Obj.pSecurityDescriptor,esi
	mov Obj.pSecurityQualityOfService,esi
	mov D[SectionOffset][0],esi
	mov D[SectionOffset][4],esi
	push esi
	push SEC_COMMIT
	push PAGE_EXECUTE_READWRITE
	lea eax,SectionSize
	lea ecx,Obj
	lea edx,Section
	push eax
	push ecx
	push SECTION_ALL_ACCESS
	push edx
	Call ZwCreateSection
	.if !Eax
		ifdef OPT_RWE
			push PAGE_EXECUTE_READWRITE
		else
			push PAGE_EXECUTE_READ
		endif
		push esi
		push ViewShare
		lea eax,S1ze
		lea ecx,SectionOffset
		push eax
		push ecx
		push esi
		push esi
		push ExBase
		push NtCurrentProcess
		push Section
		Call ZwMapViewOfSection
		.if !Eax
			push PAGE_READWRITE
			push esi
			push ViewShare
			lea eax,S1ze
			lea ecx,SectionOffset
			push eax
			push ecx
			push esi
			push esi
			push RwBase
			push NtCurrentProcess
			push Section
			Call ZwMapViewOfSection
			mov ecx,RwBase
			.if Eax
				push eax
				push D[ecx]
				push NtCurrentProcess
				Call ZwUnmapViewOfSection
				pop eax
			.endif
		.endif
		push eax
		push Section
		Call ZwClose
		pop eax
	.endif
	ret
MmMap endp

%PSHEAP macro R
	assume fs:nothing
	mov R,fs:[TEB.Peb]
	mov R,PEB.ProcessHeap[R]
endm

MmAlloc proc uses ebx S1ze:ULONG
	%PSHEAP Eax
	invoke RtlAllocateHeap, Eax, HEAP_ZERO_MEMORY, S1ze
	ret
MmAlloc endp

MmFree proc uses ebx Base:PVOID
	%PSHEAP Eax
	invoke RtlFreeHeap, Eax, 0, Base
	ret
MmFree endp

; Use RM/WE map.

MmBuild proc S1ze:ULONG
Local Base:PVOID
	and Base,NULL
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr Base, 0, addr S1ze, MEM_COMMIT, PAGE_EXECUTE_READWRITE
	.if !Eax
		mov eax,Base
	.else
		xor eax,eax
	.endif
	ret
MmBuild endp

MmProtect proc Base:PVOID, S1ze:ULONG, Protect:ULONG
	invoke ZwProtectVirtualMemory, NtCurrentProcess, addr Base, addr S1ze, Protect, addr Protect
	test eax,eax
	mov edx,Protect
	setz al
	movzx eax,al
	ret
MmProtect endp

; +
; Allocate new callmap.
; 
CmAlloc proc uses esi edi Thunk:PVOID, Map:PPVOID
Local RwMap:PVOID
	mov esi,Map
	mov edi,64
	xor ecx,ecx
	mov D[esi],ecx
	lea edx,[edi*8 + 8]
	mov RwMap,ecx
	invoke MmMap, Edx, Esi, addr RwMap
	.if !Eax
		; P = $ + D + 5
		; D = P - $ - 5
		; D'= D - 8
		mov eax,Thunk
		mov edx,RwMap
		sub eax,D[esi]
		sub eax,5
		.repeat
			mov B[edx][0],0E8H
			mov D[edx][1],eax
			mov B[edx][5],90H
			mov W[edx][6],2ECDH
			add edx,8
			sub eax,8
			dec edi
		.until Zero?
		invoke ZwUnmapViewOfSection, NtCurrentProcess, RwMap
		mov eax,TRUE
	.endif
	ret
CmAlloc endp