DISASM_MODE_32	equ 1
DISASM_MODE_64	equ 2


F_MODRM		equ 0
F_SIB		equ 1
F_DISP_8		equ 4
F_DISP_16		equ 5
F_DISP_32		equ 6
F_IMM_8		equ 8
F_IMM_16		equ 9
F_IMM_32		equ 10
F_IMM_64		equ 11
F_REL		equ 12
F_COP_IMM_DISP	equ 13
F_PFX_66		equ 14
F_PFX_67		equ 15
F_PFX_SEG		equ 16
F_PFX_REP		equ 17
F_PFX_LOCK	equ 18
F_PFX_REX		equ 19
F_ERROR		equ 20

DIZAHEX struct
	Mode		BYTE ?
	Len		BYTE ?
	Pfx66	BYTE ?
	Pfx67	BYTE ?
	
	PfxSeg	BYTE ?
	PfxRep	BYTE ?
	PfxLock	BYTE ?
	PfxRex	BYTE ?
	
	Opcode	BYTE ?
	Opcode2	BYTE ?
	ModRM	BYTE ?
	Sib		BYTE ?
union Disp
	Disp8	BYTE ?
	Disp16	WORD ?
	Disp32	DWORD ?
ends
union Imm
	Imm8		BYTE ?
	Imm16	WORD ?
	Imm32	DWORD ?
	Imm64	QWORD ?
ends
	Flags	DWORD ?
DIZAHEX ends
PDIZAHEX typedef ptr DIZAHEX

dizahex_disasm proto C pCode:PVOID, pDiza:PDIZAHEX
dizahex_asm proto C pCode:PVOID, pDiza:PDIZAHEX
